var script_elms = document.getElementsByTagName("script");
var path_bunkatsu = script_elms[script_elms.length - 1].src.split("/");
path_bunkatsu[path_bunkatsu.length - 1] = "";
path_bunkatsu[path_bunkatsu.length - 2] = "";
var dir_path = path_bunkatsu.join("/");
dir_path = dir_path.substr(0, dir_path.length - 1);

var menu_elm;
var menu_button_elm;
var q_cnt_elm;
var content_elm;
var image_box_elm;
var char_cnt_elm;
var image_button_elm;
var image_select_elms;
var post_button_elm;
var account_checkbox_elms;
var twitter_checkbox_elms;
var please_wait_elm;
var screen_elm;
var image_edit_elm;
var edit_area_elm;
var image_preview_elm;
var image_over_elm;
var image_tab_button_elms;
var image_dialog_elms;
var rotate_angle_elm;
var x0_elm;
var y0_elm;
var x1_elm;
var y1_elm;
var moving = false;
var moving_x0 = 0;
var moving_y0 = 0;
var moving_angle_old = 0;
var moving_angle0 = 0;

var question_id = "";
var contnt_max_length = 140;

var editing_image = 0;
var image_transformation = new Array({}, {}, {}, {});
var image_edit_mode;

var user_id;
var user_name;
var one_time_token;
var question_check_time_old = 0;

window.addEventListener("load", function(){
    load_user_data();
    
    menu_elm = document.getElementById("menu");
    menu_button_elm = document.getElementById("menu_button");
    q_cnt_elm = document.getElementById("q_cnt");
    content_elm = document.getElementById("content");
    char_cnt_elm = document.getElementById("char_cnt");
    image_button_elm = document.getElementById("image_button");
    post_button_elm = document.getElementById("post_button");
    account_checkbox_elms = document.getElementsByClassName("account_checkbox");
    twitter_checkbox_elms = document.getElementsByClassName("twitter_checkbox");
    please_wait_elm = document.getElementById("please_wait");
    screen_elm = document.getElementById("popup_screen");
    
    menu_button_elm.addEventListener("click", function(){menu_click();});
    content_elm.addEventListener("keyup", char_cnt);
    content_elm.addEventListener("paste", char_cnt);
    content_elm.addEventListener("cut", char_cnt);
    post_button_elm.addEventListener("click", function(){send_content();});
    
    if (location.search.indexOf("question_id=" ,1) !== -1) {
        var question_id_start = location.search.indexOf("question_id=" ,1) + 12;
        var question_id_end = location.search.indexOf("&" ,question_id_start);
        if (question_id_end === -1) {
            question_id_end = location.search.length;
        }
        question_id = location.search.substring(question_id_start, question_id_end);
        
        document.getElementsByClassName("question_image")[0].src = "question/image.php/" + question_id;
        
        content_elm.placeholder = "ここに回答を入力してください";
        
        contnt_max_length = 120;
        document.getElementById("char_cnt_max").innerText = "120";
        
        image_button_elm.style.display = "none";
    } else {
        image_edit_elm = document.getElementById("image_edit");
        
        image_select_elms = document.getElementsByClassName("image_select");
        image_box_elm = document.getElementById("image_box");
        edit_area_elm = document.getElementById("image_edit_area");
        image_preview_elm = document.getElementById("image_preview");
        image_over_elm = document.getElementById("image_over");
        image_tab_button_elms = document.getElementById("image_edit_tab").getElementsByTagName("button");
        image_dialog_elms = document.getElementsByClassName("image_edit_dialog");
        rotate_angle_elm = document.getElementById("rotate_image_angle");
        x0_elm = document.getElementById("trimming_x0");
        y0_elm = document.getElementById("trimming_y0");
        x1_elm = document.getElementById("trimming_x1");
        y1_elm = document.getElementById("trimming_y1");
        
        for (var cnt = 0; cnt < image_select_elms.length; cnt++) {
            image_select_elms[cnt].addEventListener("change", show_image);
        }
        
        image_over_elm.addEventListener("mousedown", moving_start);
        image_over_elm.addEventListener("mousemove", moving_move);
        image_over_elm.addEventListener("mouseup", moving_end);
        image_over_elm.addEventListener("touchstart", moving_start);
        image_over_elm.addEventListener("touchmove", moving_move);
        image_over_elm.addEventListener("touchend", moving_end);
        
        rotate_angle_elm.addEventListener("change", function(){rotate_image(rotate_angle_elm.value);});
        x0_elm.addEventListener("change", trimming_preview);
        y0_elm.addEventListener("change", trimming_preview);
        x1_elm.addEventListener("change", trimming_preview);
        y1_elm.addEventListener("change", trimming_preview);
    }
});

function menu_click(force_close = false) {
    if (menu_elm.className === "menu_open" || force_close) {
        menu_elm.className = "";
        menu_button_elm.style.backgroundColor = "transparent";
    } else {
        menu_elm.className = "menu_open";
        menu_button_elm.style.backgroundColor = "#7799bb";
    }
}

function get_euc_length(str) {
    return encodeURI(str).replace(/%E.%..%../g, "**").replace(/%../g, "*").length;
}

function char_cnt() {
    var mozisu = get_euc_length(content_elm.value) / 2;
    
    if (mozisu >= contnt_max_length) {
        post_button_elm.disabled = true;
        char_cnt_elm.style.color = "#ff0000";
    } else {
        post_button_elm.disabled = false;
        
        if (mozisu >= (contnt_max_length - 10)) {
            char_cnt_elm.style.color = "#ffcc00";
        } else {
            char_cnt_elm.style.color = "";
        }
    }
    
    char_cnt_elm.innerText = mozisu;
}

function show_image(){
    for (var cnt = 0; cnt < 4 && image_select_elms[cnt].files.length; cnt++) {}
    
    var fr = new FileReader();
    if (image_select_elms[cnt - 1].files[0].type.match("image.*")) {
        image_box_elm.innerHTML += "<div class='image_wrapper'><img id='up_image_" + (cnt - 1) + "' src='' alt=''><div id='trimming_frame_" + (cnt - 1) + "' class='trimming_frame'></div><div class='image_tool'></div></div>";
        
        fr.onload = function(ev){
            var image_elm = document.getElementById("up_image_" + (cnt - 1));
            image_elm.src = ev.target.result;
        };
        
        fr.readAsDataURL(image_select_elms[cnt - 1].files[0]);
    } else {
        alert("画像として読み込めないファイルが選択されました");
        image_select_elms[cnt - 1].value = "";
        return;
    }
    
    image_select_elms[cnt - 1].style.display = "none";
    
    if (cnt === 4) {
        image_button_elm.className = "image_button_disabled";
    } else {
        image_select_elms[cnt].style.display = "block";
    }
    
    image_tool_refresh();
    image_box_elm.scrollLeft = image_box_elm.scrollWidth;
}

function image_tool_refresh() {
    var image_tool_elms = document.getElementsByClassName("image_tool");
    for (var cnt = 0; cnt < image_tool_elms.length; cnt++) {
        image_tool_elms[cnt].innerHTML = "<button onclick='edit_image(" + cnt + ");' class='edit_image_button'></button><button onclick='delete_image(" + cnt + ");' class='delete_image_button'></button>";
    }
}

function delete_image(num, no_confirm = false) {
    if (!no_confirm && !confirm("この画像の投稿を取りやめますか？")) {
        return;
    }
    
    image_box_elm.removeChild(document.getElementsByClassName("image_wrapper")[num]);
    
    for (var cnt = num; cnt < 3; cnt++){
        image_button_elm.insertBefore(image_select_elms[cnt + 1], image_select_elms[cnt]);
        image_transformation[cnt] = image_transformation[cnt + 1];
        
        var up_image_elm = document.getElementById("up_image_" + (cnt + 1));
        if (up_image_elm !== null) {
            up_image_elm.id = "up_image_" + cnt;
        }
    }
    
    image_select_elms[3].value = "";
    image_transformation[3] = {};
    
    if (image_select_elms[2].files.length) {
        image_select_elms[3].style.display = "inline-block";
        image_button_elm.className = "";
    }
    
    image_tool_refresh();
}

function edit_image(num) {
    if (window.innerWidth > 500) {
        edit_area_elm.style.width = "500px";
        edit_area_elm.style.height = "500px";
        edit_area_elm.style.lineHeight = "500px";
        
        for (var cnt = 0; cnt < image_dialog_elms.length; cnt++) {
            image_dialog_elms[cnt].style.minHeight = "calc(100vh - 630px)";
        }
    }
    
    editing_image = num;
    
    image_edit_elm.style.display = "block";
    
    image_preview_elm.src = document.getElementById("up_image_" + num).src;
    image_dialog_active(0);
    set_image_edit_mode("rotate");
    moving_angle_old = 0;
    
    if (typeof image_transformation[num]["trimming"] !== "undefined") {
        x0_elm.value = image_transformation[num]["trimming"]["x0"];
        y0_elm.value = image_transformation[num]["trimming"]["y0"];
        x1_elm.value = image_transformation[num]["trimming"]["x1"];
        y1_elm.value = image_transformation[num]["trimming"]["y1"];
    } else {
        trimming_reset();
    }
    
    if (typeof image_transformation[num]["rotate"] !== "undefined") {
        rotate_angle_elm.value = image_transformation[num]["rotate"];
        rotate_image(image_transformation[num]["rotate"]);
    } else {
        rotate_angle_elm.value = "0";
        rotate_image(0);
    }
}

function set_image_edit_mode(edit_mode) {
    image_edit_mode = edit_mode;
}

function image_over_adjust() {
    var area_rect = edit_area_elm.getBoundingClientRect();
    var image_rect = image_preview_elm.getBoundingClientRect();
    
    image_over_elm.style.left = image_rect.left - area_rect.left + "px";
    image_over_elm.style.top = image_rect.top - area_rect.top + "px";
    image_over_elm.style.width = image_rect.right - image_rect.left + "px";
    image_over_elm.style.height = image_rect.bottom - image_rect.top + "px";
}

function image_dialog_active(num) {
    for (var cnt = 0; cnt < image_dialog_elms.length; cnt++) {
        image_tab_button_elms[cnt].className = "";
        image_dialog_elms[cnt].style.display = "";
    }
    
    image_tab_button_elms[num].className = "image_edit_tab_active";
    image_dialog_elms[num].style.display = "block";
}

function popup_close(id) {
    document.getElementById(id).style.display = "none";
}

function rotate_image(deg) {
    image_preview_elm.style.width = "";
    image_preview_elm.style.transform = "";
    
    image_preview_elm.style.transform = "rotate(" + deg + "deg)";
    document.getElementById("up_image_" + editing_image).style.transform = "rotate(" + deg + "deg)";
    
    image_transformation[editing_image]["rotate"] = Number(deg);
    
    image_over_adjust();
    trimming_preview();
}

function set_rotate_angle(deg, update_angle_old = true) {
    rotate_angle_elm.value = deg;
    rotate_image(deg);
    
    if (update_angle_old) {
        moving_angle_old = Number(rotate_angle_elm.value);
    }
}

function trimming_preview(){
    var top_elm = document.getElementById("image_trimmed_top");
    var left_elm = document.getElementById("image_trimmed_left");
    var right_elm = document.getElementById("image_trimmed_right");
    var bottom_elm = document.getElementById("image_trimmed_bottom");
    var frame_elm = document.getElementById("image_trimmed_frame");
    var box_frame_elm = document.getElementById("trimming_frame_" + editing_image);
    var up_image_elm = document.getElementById("up_image_" + editing_image);
    var wrapper_elm = up_image_elm.parentNode;
    
    var x0 = Number(x0_elm.value) / 100;
    var y0 = Number(y0_elm.value) / 100;
    var x1 = Number(x1_elm.value) / 100;
    var y1 = Number(y1_elm.value) / 100;
    
    var tmp;
    if (x0 > x1) {
        tmp = x0;
        x0 = x1;
        x1 = tmp;
    }
    
    if (y0 >= y1) {
        tmp = y0;
        y0 = y1;
        y1 = tmp;
    }
    
    var area_rect = edit_area_elm.getBoundingClientRect();
    var image_rect = image_over_elm.getBoundingClientRect();
    var wrapper_rect = wrapper_elm.getBoundingClientRect();
    var up_image_rect = up_image_elm.getBoundingClientRect();
    
    var image_width = image_rect.right - image_rect.left;
    var image_height = image_rect.bottom - image_rect.top;
    var up_image_width = up_image_rect.right - up_image_rect.left;
    var up_image_height = up_image_rect.bottom - up_image_rect.top;
    
    var image_left = image_rect.left - area_rect.left;
    var image_top = image_rect.top - area_rect.top;
    var up_image_left = up_image_rect.left - wrapper_rect.left;
    var up_image_top = up_image_rect.top - wrapper_rect.top;
    
    var x0_px = image_left + image_width * x0;
    var y0_px = image_top + image_height * y0;
    var x1_px = image_left + image_width * x1;
    var y1_px = image_top + image_height * y1;
    var box_x0_px = up_image_left + up_image_width * x0;
    var box_y0_px = up_image_top + up_image_height * y0;
    var box_x1_px = up_image_left + up_image_width * x1;
    var box_y1_px = up_image_top + up_image_height * y1;
    
    top_elm.style.left = image_left + "px";
    top_elm.style.top = image_top + "px";
    top_elm.style.width = image_width + "px";
    top_elm.style.height = y0_px - image_top + "px";
    
    left_elm.style.left = image_left + "px";
    left_elm.style.top = y0_px + "px";
    left_elm.style.width = x0_px - image_left + "px";
    left_elm.style.height = y1_px - y0_px + "px";
    
    right_elm.style.left = x1_px + "px";
    right_elm.style.top = y0_px + "px";
    right_elm.style.width = image_left + image_width - x1_px + "px";
    right_elm.style.height = y1_px - y0_px + "px";
    
    bottom_elm.style.left = image_left + "px";
    bottom_elm.style.top = y1_px + "px";
    bottom_elm.style.width = image_width + "px";
    bottom_elm.style.height = image_top + image_height - y1_px + "px";
    
    frame_elm.style.display = "block";
    frame_elm.style.left = x0_px - 2 + "px";
    frame_elm.style.top = y0_px - 2 + "px";
    frame_elm.style.width = x1_px - x0_px + "px";
    frame_elm.style.height = y1_px - y0_px + "px";
    
    if (x1 - x0 !== 1.0 || y1 - y0 !== 1.0) {
        box_frame_elm.style.display = "block";
        box_frame_elm.style.left = box_x0_px - 2 + "px";
        box_frame_elm.style.top = box_y0_px - 2 + "px";
        box_frame_elm.style.width = box_x1_px - box_x0_px + "px";
        box_frame_elm.style.height = box_y1_px - box_y0_px + "px";
    } else {
        box_frame_elm.style.display = "none";
    }
    
    image_transformation[editing_image]["trimming"] = {
        "x0": Number(x0_elm.value),
        "y0": Number(y0_elm.value),
        "x1": Number(x1_elm.value),
        "y1": Number(y1_elm.value)
    };
}

function trimming_reset() {
    x0_elm.value = 0;
    y0_elm.value = 0;
    x1_elm.value = 100;
    y1_elm.value = 100;
    
    trimming_preview();
}

function moving_start(ev) {
    moving = true;
    
    if (typeof ev.touches !== "undefined"){
        var clientX = ev.touches[0].clientX;
        var clientY = ev.touches[0].clientY;
    } else {
        var clientX = ev.clientX;
        var clientY = ev.clientY;
    }
    
    var image_rect = image_over_elm.getBoundingClientRect();
    
    var offsetX = clientX - image_rect.left;
    var offsetY = clientY - image_rect.top;
    
    moving_x0 = Math.round(offsetX / (image_rect.right - image_rect.left) * 100);
    moving_y0 = Math.round(offsetY / (image_rect.bottom - image_rect.top) * 100);
    
    switch (image_edit_mode) {
        case "rotate":
            var center_x = (image_rect.left + image_rect.right) / 2;
            var center_y = (image_rect.top + image_rect.bottom) / 2;
            
            moving_angle0 = Math.round(Math.atan((center_x - clientX) / (center_y - clientY)) / Math.PI * 180);
            
            if (clientY > center_y) {
                moving_angle0 += 180;
            }
            break;
        case "trimming":
            x0_elm.value = correct_percent(moving_x0);
            y0_elm.value = correct_percent(moving_y0);
            break;
    }
}

function moving_move(ev) {
    if (!moving) {
        return;
    }
    
    if (typeof ev.touches !== "undefined"){
        var clientX = ev.touches[0].clientX;
        var clientY = ev.touches[0].clientY;
    } else {
        var clientX = ev.clientX;
        var clientY = ev.clientY;
    }
    
    var image_rect = image_over_elm.getBoundingClientRect();
    
    var offsetX = clientX -  image_rect.left;
    var offsetY = clientY - image_rect.top;
    
    var moving_x1 = Math.round(offsetX / (image_rect.right - image_rect.left) * 100);
    var moving_y1 = Math.round(offsetY / (image_rect.bottom - image_rect.top) * 100);
    
    switch (image_edit_mode) {
        case "rotate":
            var center_x = (image_rect.left + image_rect.right) / 2;
            var center_y = (image_rect.top + image_rect.bottom) / 2;
            
            var angle = moving_angle0 - Math.round(Math.atan((center_x - clientX) / (center_y - clientY)) / Math.PI * 180) + moving_angle_old;
            
            if (clientY > center_y) {
                angle += 180;
            }
            
            set_rotate_angle((angle + 180) % 360 - 180, false);
            
            break;
        case "trimming":
            x1_elm.value = correct_percent(moving_x1);
            y1_elm.value = correct_percent(moving_y1);
            
            trimming_preview();
            
            break;
    }
    
    ev.preventDefault();
    return false;
}

function moving_end() {
    moving = false;
    
    if (image_edit_mode === "rotate") {
        moving_angle_old = Number(rotate_angle_elm.value);
    }
}

function correct_percent(val) {
    if (val > 100) {
        val = 100;
    } else if (val < 0) {
        val = 0;
    }
    
    return val;
}

function open_square_popup(id) {
    screen_elm.style.display = "block";
    document.getElementById(id).style.display = "block";
}

function close_square_popup(id, keep_screen_open = false) {
    if (!keep_screen_open) {
        screen_elm.style.display = "none";
    }
    
    document.getElementById(id).style.display = "none";
    
    menu_click(true);
}

function load_user_data() {
    var request_obj = new XMLHttpRequest();
    
    request_obj.onreadystatechange = function(){
        if(request_obj.readyState === 4 && request_obj.status === 200) {
            if (request_obj.responseText !== "<ERROR>") {
                var user_data = JSON.parse(request_obj.responseText);
                
                user_id = user_data["user_id"];
                user_name = user_data["user_name"];
                
                var accounts_elm = document.getElementById("accounts");
                var class_add = "";
                var checked = "";
                accounts_elm.innerHTML = "";
                for (var cnt = 0; cnt < user_data["sns_accounts"].length; cnt++) {
                    if (user_data["sns_accounts"][cnt]["instance_url"] == "twitter.com") {
                        class_add = " twitter_checkbox";
                    } else {
                        class_add = " mastodon_checkbox";
                    }
                    
                    if (user_data["sns_accounts"][cnt]["checked"]) {
                        checked = " checked='checked'";
                    } else {
                        checked = "";
                    }
                    
                    accounts_elm.innerHTML += "<input type='checkbox' id='account_" + cnt + "'" + checked + " class='account_checkbox" + class_add + "'><label for='account_" + cnt + "'>" + user_data["sns_accounts"][cnt]["display_name"] + "</label><br>";
                }
                
                if (cnt === 0) {
                    accounts_elm.innerHTML = "<span style='color: #ff0000;'>SNSアカウントが登録されていません。右上のメニューからSNSアカウントを追加してください。</span>";
                }
                
                update_one_time_token();
            } else {
                location.href = "login.php";
            }
        }
    };
    
    request_obj.open("GET", "addition/user_data.php", true);
    request_obj.send();
}

function update_one_time_token() {
    var request_obj = new XMLHttpRequest();
    
    request_obj.onreadystatechange = function(){
        if(request_obj.readyState === 4 && request_obj.status === 200) {
            if (request_obj.responseText !== "<ERROR>") {
                one_time_token = request_obj.responseText;
            } else {
                alert("内部エラーが発生しました。\nアプリを再起動してください。");
            }
        }
    };
    
    request_obj.open("GET", "addition/one_time_token.php", true);
    request_obj.send();
}

function send_content(content = null) {
    if (content_elm.value.length === 0 && content === null) {
        alert("本文が未入力です");
        return;
    }
    
    var twitter_selected = 0;
    for (var cnt = 0; cnt < twitter_checkbox_elms.length; cnt++) {
        if (twitter_checkbox_elms[cnt].checked) {
            twitter_selected++;
        }
    }
    if (twitter_selected >= 2) {
        alert("Twitterの規約により複数のTwitterアカウントへの同一内容投稿は制限されています");
        return;
    }
    
    var account_order_numbers = "";
    for (var cnt = 0; cnt < account_checkbox_elms.length; cnt++) {
        if (account_checkbox_elms[cnt].checked) {
            if (account_order_numbers.length !== 0) {
                account_order_numbers += ",";
            }
            
            account_order_numbers += (cnt + 1);
        }
    }
    
    if (account_order_numbers.length === 0) {
        alert("SNSアカウントが選択されていません");
        return;
    }
    
    please_wait_elm.style.display = "block";
    
    var request_obj = new XMLHttpRequest();
    
    request_obj.onreadystatechange = function(){
        if(request_obj.readyState === 4) {
            please_wait_elm.style.display = "none";
            if(request_obj.status === 200) {
                if (request_obj.responseText === "[EOF]") {
                    if (question_id !== "") {
                        alert("回答を投稿しました");
                        location.href = "index.php";
                    }
                    
                    content_elm.value = "";
                    for (var cnt = f_cnt; cnt > 0; cnt--) {
                        delete_image(cnt - 1, true);
                    }
                    
                    char_cnt();
                    
                    alert("正常に送信されました");
                }else{
                    alert("【エラー】\n" + request_obj.responseText);
                }
            }
            
            update_one_time_token();
        }
    };
    
    request_obj.open("POST", "addition/send_content.php", true);
    
    var form_data = new FormData();
    if (content === null) {
        form_data.append("content", encodeURIComponent(content_elm.value));
    } else {
        form_data.append("content", encodeURIComponent(content));
    }
    form_data.append("account_order_numbers", account_order_numbers);
    form_data.append("one_time_token", one_time_token);
    
    if (question_id !== "") {
        form_data.append("question_id", question_id);
    } else {
        for (var f_cnt = 0; f_cnt < 4 && image_select_elms[f_cnt].files.length; f_cnt++) {
            form_data.append("image_" + f_cnt, image_select_elms[f_cnt].files[0], image_select_elms[f_cnt].files[0].name);
        }
        
        if (f_cnt >= 1) {
            form_data.append("image_transformation", JSON.stringify(image_transformation));
        }
    }
    
    request_obj.send(form_data);
}

function request_question() {
    if (!confirm("選択中の投稿先SNSに「" + user_name + "」として匿名質問の募集文を投稿しますか？")) {
        return;
    }
    
    send_content("匿名質問を募集しています！\n" + dir_path + "question/index.php/" + user_id);
}

function update_unread_questions() {
    var request_obj = new XMLHttpRequest();
    
    request_obj.onreadystatechange = function(){
        if(request_obj.readyState === 4 && request_obj.status === 200) {
            if (request_obj.responseText !== "<ERROR>") {
                q_cnt_elm.innerText = "(新着 " + request_obj.responseText + ")";
                if (Number(request_obj.responseText) === 0) {
                    menu_button_elm.className = "";
                    q_cnt_elm.style.color = "";
                } else {
                    menu_button_elm.className = "menu_button_notice";
                    q_cnt_elm.style.color = "#ff3300";
                }
            } else {
                alert("内部エラーが発生しました。\nアプリを再起動してください。");
            }
        }
    };
    
    request_obj.open("GET", "addition/count_unread_questions.php", true);
    request_obj.send();
}
setInterval(function() {
    var question_check_time = Math.floor((new Date()).getTime() / 1000);
    
    if (question_check_time - question_check_time_old >= 900) {
        question_check_time_old = question_check_time;
        update_unread_questions();
    }
}, 20000);

function logout_this_app() {
    if (confirm("アプリからログアウトしますか？")) {
        location.href = "login.php?logout=true";
    }
}

if (("serviceWorker" in navigator) && (window.location.protocol.substr(0, 4) === "http")) {
    navigator.serviceWorker.register("service_worker.js");
}