<?php
include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if ($user_id == FALSE) {
    header("Location: ../login.php");
    exit(0);
}

include "../modules/question.php";
include "../modules/info.php";
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>質問に回答する | <?php print APPLICATION_NAME; ?></title>
    <link rel="stylesheet" href="../main.css" type="text/css">
    <link rel="shortcut icon" href="../favicon.ico">
</head>
<body>
    <header onclick="location.href = '../';" style="cursor: pointer;"><?php print APPLICATION_NAME; ?></header>
<?php
if (empty($_GET["question_id"])) {
    if (isset($_POST["delete"], $_POST["question_id"])) {
        if ($wakarana->check_one_time_token($user_id,$_POST["token"])) {
            delete_question($user_id, $_POST["question_id"]);
        } else {
            print "<div id='login_error'>ワンタイムトークンが無効です</div>\n";
        }
    }
    
    $data = get_questions_to_user($user_id);
    
    $last_read = get_last_question_read($user_id);
    update_question_read_datetime($user_id);
    
    print "<h3>未回答の質問一覧</h3>";
    print "<div id='question_list'>";
    
    for ($cnt = 0; isset($data[$cnt]); $cnt++) {
        print "<a href='answer.php?question_id=".$data[$cnt]["question_id"]."'>".htmlspecialchars($data[$cnt]["question"])."</a>";
    }
    
    if ($cnt == 0) {
        print "未回答の質問はありません";
    }
    
    print "</div>";
    print "　<a href='../'>&lt;&lt;戻る</a>";
} else {
    $q_data = get_question($_GET["question_id"]);
    print "<br><img src='image.php/".$q_data["question_id"]."' alt='".addslashes($q_data["question"])."' class='question_image'><br>";
    print "　<a href='answer.php'>&lt;&lt;戻る</a>";
    print "<button id='post_button' onclick='location.href = \"../index.php?question_id=".$_GET["question_id"]."\";'>この質問に答える</button><br><br><br>";
    print "<a href='javascript: void(0);' onclick='if(confirm(\"この質問を削除しますか？\")){ document.getElementById(\"delete_form\").submit(); }' style='float: right; margin-right: 20px;'>この質問を削除</a>";
    print "<form id='delete_form' action='answer.php' method='post' style='display: hidden'><input type='hidden' name='delete' value='true'><input type='hidden' name='question_id' value='".addslashes($_GET["question_id"])."'><input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'></form>";
}
?>
</body>
</html>
