<?php
include "../modules/question.php";
include "../modules/info.php";

if (!empty($_SERVER["PATH_INFO"]) && !empty(substr($_SERVER["PATH_INFO"], 1))) {
    $q_data = get_question(substr($_SERVER["PATH_INFO"], 1));
    if (empty($q_data)) {
        print "指定された質問IDは存在しません";
        exit();
    }
} else {
    print "質問IDが指定されていません";
    exit();
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>匿名質問を送信しました</title>
    <link rel="stylesheet" href="../../main.css" type="text/css">
    <link rel="shortcut icon" href="../../favicon.ico">
</head>
<body>
    <header>匿名質問</header>
    <h3>匿名質問を送信しました</h3>
<?php
print "<img src='../image.php/".$q_data["question_id"]."' alt='".addslashes($q_data["question"])."' class='question_image'><br>";
print "<button id='post_button' onclick='location.href = \"../index.php/".$q_data["user_id"]."\";'>戻る</button>";
?>
    <span id="powered_by">Powered by <a href="../../"><?php print APPLICATION_NAME; ?></a></span>
</body>
</html>
