<?php
include "../lib/wakarana/main.php";

$wakarana = new wakarana();
$user_id = $wakarana->check();
if ($user_id == FALSE) {
    header("Location: ../login.php");
    exit(0);
}
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>各種設定 | <?php print APPLICATION_NAME; ?></title>
    <link rel="stylesheet" href="../main.css" type="text/css">
    <link rel="shortcut icon" href="../favicon.ico">
</head>
<body>
    <button class="popup_close_button" onclick="location.href = '../index.php';">×</button>
    <h2>各種設定</h2>
<?php
if (isset($_POST["user_name"])) {
    if (isset($_POST["token"]) && $wakarana->check_one_time_token($user_id,$_POST["token"])) {
        $wakarana->change_user_data($user_id, NULL, $_POST["user_name"]);
        print "<span style='font-size: x-large;'>ユーザーデータを保存しました。</span><br><br>";
        
        if (!empty($_POST["old_pass"]) && !empty($_POST["new_pass"])) {
           if ($wakarana->check_password($user_id, $_POST["old_pass"])) {
                $wakarana->change_user_data($user_id, $_POST["new_pass"]);
                
                print "<span style='font-size: x-large;'>パスワードを変更しました。</span><br><br>";
            } else {
                print "<span style='font-size: x-large; color: #ff0000;'>エラー : 元のパスワードが間違っています。<br>パスワードの変更は破棄されました。</span><br><br>";
            }
        }
    } else {
        print "<span style='font-size: x-large; color: #ff0000;'>ワンタイムトークンが無効です。<br>変更は破棄されました。</span><br><br>";
    }
}
?>
    <h3>ユーザーID</h3>
<?php
$user_info = $wakarana->get_user_info($user_id);

print "　<b style='font-size: large;'>".$user_id."</b>";
?>

<form action='config.php' method='post' class="popup_form">
<h3>ハンドルネーム</h3>
<?php
print "<input type='text' name='user_name' value='".addslashes($user_info["user_name"])."'>";
?>
<h3>パスワードの変更</h3>
パスワードを変更しない場合、以下は空欄にしてください

<h4>元のパスワード</h4>
現在のパスワードを入力してください<br>
<input type="password" name="old_pass">

<h4>新しいパスワード</h4>
新しく設定するパスワードを入力してください<br>
<input type="password" name="new_pass">

<br><br>

<?php print "<input type='hidden' name='token' value='".$wakarana->create_one_time_token($user_id)."'>"; ?>

<button type='submit'>変更確定</button>
</form>
</body>
</html>
