<?php
include "lib/wakarana/main.php";

$wakarana = new wakarana();

if (isset($_GET["logout"])) {
    $wakarana->logout();
}

if ($wakarana->check() != FALSE) {
    header("Location: index.php");
}

if (isset($_POST["user"],$_POST["password"])) {
    if ($wakarana->login($_POST["user"],$_POST["password"])) {
        header("Location: index.php");
        
        exit(0);
    }
    
    $login_reject = TRUE;
}else{
    $login_reject = FALSE;
}

include "modules/info.php";
?><!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title>ログイン | <?php print APPLICATION_NAME; ?></title>
    <meta property="og:title" content="<?php print APPLICATION_NAME; ?>">
    <meta property="og:description" content="SNSクライアント <?php print APPLICATION_NAME; ?>">
    <meta property="og:image" content="<?php print get_application_url(); ?>images/large_image.png">
    <meta property="twitter:card" content="summary_large_image">
    <link rel="stylesheet" href="main.css" type="text/css">
    <link rel="apple-touch-icon" href="apple-touch-icon.png">
    <link rel="shortcut icon" href="favicon.ico">
</head>
<body>
    <header><?php print APPLICATION_NAME; ?></header>
    <h1>ログイン</h1>
<?php
if ($login_reject) {
    print "<div id='login_error'>入力に誤りがありました。再入力してください。</div>\n";
}
?>
    <div id="form_box">
        <form method="post" action="login.php">
            ユーザー名<input type="text" name="user">
            パスワード<input type="password" name="password">
            <button type="submit">ログイン</button>
        </form>
        <button id="sign_up_button" onclick="location.href = 'sign_up.php';">新規登録</button>
    </div>
<?php
$sa_config = parse_ini_file("data/social_amniote.ini");

print "<span id='powered_by'><a href='".$sa_config["introduction_url"]."' target='_blank'>このアプリについて</a></span>";
?>
</body>
</html>