<?php
include "../modules/question.php";

$sa_config = parse_ini_file("../data/social_amniote.ini");

$img = imagecreatefrompng("../images/question_background.png");

if (!empty($_SERVER["PATH_INFO"]) && !empty(substr($_SERVER["PATH_INFO"], 1))) {
    $q_data = get_question(substr($_SERVER["PATH_INFO"], 1));
    if (!empty($q_data)) {
        $question = $q_data["question"];
    } else{
        $question = "【エラー】\n指定された質問IDは存在しません";
    }
} elseif (isset($_GET["test_mes"])) {
    $question = $_GET["test_mes"];
} else {
    $question = "【エラー】\n質問IDが指定されていません";
}

$kakugyo = split_question($question);
$gyosu = count($kakugyo);

if ($gyosu == 1){
    $b_box = imagettfbbox($sa_config["question_font_size"], 0, $sa_config["question_font"], $kakugyo[0]);
    $text_x = 600 - round($b_box[2] / 2);
} else {
    $text_x = 64;
}
$line_height = round($sa_config["question_font_size"] * 1.8);
$start_y = 360 - round($line_height * ($gyosu - 1) / 2);
for ($cnt = 0; $cnt < $gyosu; $cnt++) {
    imagettftext($img, $sa_config["question_font_size"], 0, $text_x, $cnt * $line_height + $start_y, 0x333333, $sa_config["question_font"], $kakugyo[$cnt]);
}

header("Content-Type: image/png");
imagepng($img, NULL, 9);